#!/usr/bin/perl -w
#    this script is design to work with Sympa (sympa.org) as a alternative alias manager.
#    It is simmular to the ldap_alias_manager.pl script, but include list owners as ldap attributes.
#    Please review the script, and configure to your likeing.  
##
#    Copyright (C) 2009  Christopher Pax <pax@njit.edu>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

use strict;

use Net::LDAP;
use Net::LDAP::Entry;
use DBI;
use Config::General;
use Data::Dumper;

package main;

my ($action, $listname, $robot) = @ARGV;
#print $action."-". $listname."-".$robot;

my $conf = new Config::General("/path/to/settings.conf"); 
my %config = $conf->getall;

#print Dumper(\%config);

#print "\ndatabase host:".$config{"database"}{"host"};


my $mysql = DBI->connect("DBI:mysql:database=".$config{'database'}{'database_name'}.";host=".$config{'database'}{'host'},
                         $config{"database"}{"user"}, $config{"database"}{"password"},
                         {'RaiseError' => 1});



my $query = "             
        SELECT `user_admin`, `role_admin`, `profile_admin` FROM admin_table a where
        robot_admin= '$robot' and
        list_admin = '$listname' and
	role_admin = 'owner';";
    
#=cut
my $dbresults = $mysql->prepare($query);
if(!$dbresults){
	die "Error:" . $dbresults->errstr . "\n";
}
if($dbresults->rows < 0){
	print "Error: no owners defined in database.";
	exit(0);
}

#my %ref = {};
$dbresults->execute();
my @owners = ();
while (my $row = $dbresults->fetchrow_hashref()) {
	#print Dumper($row);
	#print $row->{'user_admin'},"\n";
	push(@owners, $row->{'user_admin'});
}
$dbresults->finish();
$mysql->disconnect();
#=end



 my $ldap = Net::LDAP->new(  $config{"ldap"}{"host"} ) or die "$@";

 my $mesg = $ldap->bind($config{"ldap"}{"bind_dn"}, password => $config{"ldap"}{"bind_pwd"}) ;    # an anonymous bind
#print Dumper(\%config);
   if ($mesg->is_error()) {
	#print "bind_dn:".$config{"ldap"}{"bind_dn"}."\n";
	#print "pass:".$config{"ldap"}{"bind_pwd"}."\n";
        print STDERR "Can't bind to server ".$config{"ldap"}{"host"}.": ",$mesg->error(),"\n";
        exit(0); 
    } 


if($action eq 'add'){

=pod
 $mesg = $ldap->search( # perform a search
                        base   => $config{"ldap"}{"base_dn"},
                        filter => "uid=*",
                      );

 $mesg->code && die $mesg->error;

 foreach my $entry ($mesg->entries) { $entry->dump; }
=cut


my %attrs = (
          "objectClass" => ["top","person", "organizationalPerson", "inetorgperson", "groupOfNames"],
          "cn" => [$listname],
	  "sn" => [$listname],
          "uid" => [$listname],
#	  "mail" => [$listname."\@sydlpr1.njit.edu"],
          "preferredDeliveryMethod" => ['catchall'],
          "owner" => \@owners,   
);
print "Owners: @owners\n";
my $entry = Net::LDAP::Entry->new;
#$entry->add("mail",$listname."\@".$robot);
#print "dn:"."uid=$listname,".$config{"ldap"}{"base_dn"}."\n";
my $ldapdn = "uid=$listname,".$config{"ldap"}{"base_dn"};
$entry->dn($ldapdn);

#print Dumper(\%attrs);
#print "\n DN:".$ldapdn;#$config{"ldap"}{"base_dn"};

#my $result = $ldap->add($ldapdn, attr => %attrs);

###
$entry->add("mail", $listname."\@".$robot);
# We add the rest of the attributes
        foreach my $hash_key (keys %attrs) {
            foreach my $hash_value (@{$attrs{$hash_key}}) {
                #$value = $hash_value;
                #$value =~ s/{ALIAS}/$alias_value/;
                #$value =~ s/{COMMAND}/$command_value/;
                $entry->add($hash_key, $hash_value);
            }
        }

my $result = $ldap->add($entry);
###

$result->code && warn "failed to add entry: ", $result->error ;
 $mesg = $ldap->unbind;   # take down session


}
elsif($action eq 'del'){
	
	my $ldapdn = "uid=$listname,".$config{"ldap"}{"base_dn"};
	$ldap->delete($ldapdn);
}




